#include <revolution.h>
#include <nw4r/g3d.h>
#include <nw4r/g3d/g3d_scnobj.h>
#include <nw4r/ut/WideTextWriter.h>
#include <nw4r/ut/TextWriter.h>
#include <stdlib.h>
#include <vector>
#include <revolution/sc.h>
#include <revolution/wpad.h>
#include <revolution/kpad.h>


#include "System.h"
#include "Helper.h"
#include "ResourceLoader.h"
#include "RenderObj.h"
#include "Pad.h"

#include "Effect.h"
#include "Sound.h"
#include "Font.h"
#include "rena.rsid"
#include "Dialog.h"
//#include "SPad.h"	// SPad
#include "SKPad.h"	// SKPad
#include "rena_hbm.h"
#include "global.h"
#include "mg08_main.h"
#include "MG08Map.h"
#include "MG08OsewaObj.h"
#include "MG08AutonomyObj.h"
#include "MG08Cat.h"
#include "MG08Senshu.h"
#include "MG08Pro.h"
#include "MG08Cherry.h"
#include "MG08Hand.h"
#include "MG08Block.h"
#include "MG08HelpMark.h"
#if 0
#include "MG08Dish.h"
#endif
#include "MG08Camera.h"
#include "MG08Gauge.h"
#include "MG08Timer.h"

//#define DRAW_CAMERA_INFO	// J\

#define NUM_BLOCKS	(160)
#define NUM_BBLOCKS (50)
#define NUM_CATS	(3)

static BOOL bHBM = FALSE;
int g_MG08Score = 0;
int g_MG08ClearBonus = 0;

int mg08_get_score()
{
	return g_MG08Score;
}

int mg08_get_clearbonus()
{
	return g_MG08ClearBonus;
}

void ResetCats(MG08Cat **pCats);

void ResetCats(MG08Cat **pCats)
{
	for (int i = 0; i < NUM_CATS; i++) {
		MG08Osewa3D v;
		MG08Map *pCell;
		do {
			v.x = rand() % 5; //11;
			v.z = rand() % 3;
			pCell = MG08Map::GetCell(&v);
		} while ((pCell == NULL) ||
				 (pCell->eType == CEL_JUNK) ||
			     (pCell->iHeight > 2) ||
			     (pCell->eCat != CAT_NONE));
		v.y = pCell->iHeight;
		pCats[i]->SetPos(&v);
		pCell->eCat = pCats[i]->GetCatType();
		pCell->iPos = (char)v.y;
	}
}

int mg08_main()
{
	// WPAD̃ZbgAbv
	SKPad::SKPadSetup(NO_DPD, NO_NUNCHAKU);
	// TEh
	CSound::Setup();
	CSound::LoadSoundGroup( M07_set );
#ifdef DRAW_CAMERA_INFO
	nw4r::ut::TextWriter Writer;			// `sŃeLXgC^[p
	Writer.SetFont( CFont::GetFont() );		// eLXgC^[ɃtHgZbg
#endif
	//vÕTv
	enum {
		SI_BG,
#if 1
		SI_BLOCK0,
		SI_BLOCK1,
		SI_BLOCK2,
		SI_BLOCK3,
		SI_BLOCK4,	//{[iXubN	yanai
		SI_SENSHU,
		SI_PRO,
		SI_CHERRY,
		SI_HAND,
		SI_DISH,
		SI_DISH_EMPTY,
		SI_HELP_MARK,
#else
		SI_RENA,
		SI_PLAYER,
		SI_USAGI,
		SI_USAGI_MARKER,
		SI_BALANCE,
		SI_CAM,
#endif
		SI_GAUGE,
		SI_START,
		SI_END,
		SI_TIMER
	};

	MG08Hand::InitCountTimeBonus();
	g_MG08Score = 0;
	g_MG08ClearBonus = 0;
	
	int iWaitEating = -1;
	MG08Cat::InitGoalInCats();
	bHBM = FALSE;

    int idxData = 0;
    std::vector<nw4r::g3d::ScnMdlSimple*> vecScnMdlSmpl;
    std::vector<nw4r::g3d::G3dObj*> vecObj;

    nw4r::g3d::ScnRoot* pRoot      = NULL;
    //---- ScnRoot \z܂B
    {
        u32 size;
        pRoot = nw4r::g3d::ScnRoot::Construct(GetAllocator(),    // AP[^w肵܂BNULLw肷Ǝۂɂ̓IuWFNg͍\z܂
                                              &size,                   // AP[^ɗvTCYi[܂BNULLw肷邱Ƃ\łB
                                              1024,                     // ڎq̐̍ő吔w肵܂B
                                              1024                      // c[ɑ݂ScnObj̍ő吔w肵܂B
                                              );

        NW4R_POINTER_ASSERT( pRoot );
        vecObj.push_back(pRoot);
        MG08HelpMark::s_pRoot = pRoot;
    }

	CResourceLoader* pRes=new CResourceLoader;
	pRes->AddFile( "mg08/mg08/brres/mg08.brres" );
	pRes->AddFile( "mg08/o112/brres/o112.brres" );
	pRes->AddFile( "mg08/o113/brres/o113.brres" );
	pRes->AddFile( "mg08/o114/brres/o114.brres" );
	pRes->AddFile( "mg08/o115/brres/o115.brres" );
	pRes->AddFile( "mg08/o124/o124.brres" );
//	pRes->AddFile( "mg08/co104/brres/co104.brres" );
	pRes->AddFile( "mg08/ca002/brres/ca002.brres" );
	pRes->AddFile( "mg08/ca003/brres/ca003.brres" );
	pRes->AddFile( "mg08/ca004/brres/ca004.brres" );
//	pRes->AddFile( "mg08/ch009/brres/ch009.brres" );
	pRes->AddFile( "mg08/co079/brres/co079.brres" );
	pRes->AddFile( "mg08/co064/brres/co064.brres" );
	pRes->AddFile( "mg08/co083/brres/co083.brres" );
	pRes->AddFile( "mg08/co080/brres/co080.brres" );
#if 0
	pRes->AddFile( "mg10/ca001/mg10_brres/ca001.brres" );
	pRes->AddFile( "mg10/ch004/mg10_brres/ch004.brres" );
	pRes->AddFile( "mg10/co003/brres/co003.brres" );
	pRes->AddFile( "mg10/co067/brres/co067.brres" );
#endif
	pRes->AddFile( "mg08/mg08/MG08.arc" );
#if 0
	pRes->AddFile( "mg10/cam_light/cam_light_sample/cam_light_01.brres" );
#endif
	pRes->AddFile( "lyt/co_start.arc" );
	pRes->AddFile( "lyt/co_end.arc" );
	pRes->AddFile( "lyt/co_ti_back.arc" );
	pRes->AddFile( "lyt/co_count_l.arc" );
	pRes->AddFile( "lyt/co_count_lEF.arc" );

	ShowLoadingScreen( pRes );


	int numResFile = pRes->GetNum();
	for( int i=0; i<numResFile; i++ ){
		bool bRevision;
		nw4r::g3d::ResFile resfile=pRes->GetResFile(i);
		bRevision = resfile.CheckRevision();
		NW4R_ASSERT( bRevision );
		resfile.Init();
		bool bAllBound = resfile.Bind();
		NW4R_ASSERT( bAllBound );
	}

	MG08Map::Setup(1);

	CBgItem* pBG=new CBgItem;
	pBG->Create( pRes->GetResFile(SI_BG), 0 );

	MG08Block* pBlock[NUM_BLOCKS];
	for (int i = 0; i < NUM_BLOCKS; i++) {
		pBlock[i] =new MG08Block;
		pBlock[i]->Load( pRes->GetResFile(SI_BLOCK0 + (i % 4)), 0 );
	}

	MG08Block* pBBlock[NUM_BBLOCKS];
	for( int i=0; i <NUM_BBLOCKS; i++ ){
		pBBlock[i] = new MG08Block;
		pBBlock[i]->Load( pRes->GetResFile(SI_BLOCK4), 0 );
		pBBlock[i]->GetSceneModel()->SetAnimObj( AT_TEXSRT, "o124", 0.5f, TRUE );
	}


	MG08Cat *pCats[NUM_CATS];
	for (int i = 0; i < NUM_CATS; i++) {
		if (i == 0) {
			pCats[i] = new MG08Senshu();
			pCats[i]->Load( pRes->GetResFile(SI_SENSHU), 0 );
		} else if (i == 1) {
			pCats[i] = new MG08Pro();
			pCats[i]->Load( pRes->GetResFile(SI_PRO), 0 );
		} else {
			pCats[i] = new MG08Cherry();
			pCats[i]->Load( pRes->GetResFile(SI_CHERRY), 0 );
		}
	}
	MG08Hand *pHand;
	pHand = new MG08Hand;
	pHand->Load( pRes->GetResFile(SI_HAND) );
	pHand->SetMotion(HM_IDLE);
	pHand->SetRoot(pRoot);

	CBgItem *pDish[NUM_CATS];
	CBgItem *pEmptyDish[NUM_CATS];
	for (int i = 0; i < NUM_CATS; i++) {
		pDish[i] = new CBgItem();
		pDish[i]->Create( pRes->GetResFile(SI_DISH), 0 );
		pEmptyDish[i] = new CBgItem();
		pEmptyDish[i]->Create( pRes->GetResFile(SI_DISH_EMPTY), 0 );
	}
	nw4r::math::VEC3 vDishPos(-1.2f, 0.0f, -4.5f);
	pDish[0]->SetPos(&vDishPos);
	pEmptyDish[0]->SetPos(&vDishPos);
	pEmptyDish[0]->SetVisible(FALSE);
	vDishPos.x = -1.8f;
	pDish[1]->SetPos(&vDishPos);
	pEmptyDish[1]->SetPos(&vDishPos);
	pEmptyDish[1]->SetVisible(FALSE);
	vDishPos.x = -2.4f;
	pDish[2]->SetPos(&vDishPos);
	pEmptyDish[2]->SetPos(&vDishPos);
	pEmptyDish[2]->SetVisible(FALSE);

	MG08HelpMark *pHelp[NUM_CATS];
	for (int i = 0; i < NUM_CATS; i++) {
		pHelp[i] = new MG08HelpMark();
		pHelp[i]->Load( pRes->GetResFile(SI_HELP_MARK), 0 );
		pHelp[i]->GetSceneModel()->SetAnimObj( AT_TEX, "co080", 0.5f, TRUE );
		pCats[i]->SetMyHelpMark(pHelp[i]);
	}

	int boxIndex = 0;
	int bounsboxIndex = 0;
	for (int z = 0; z < MG08MAP_Z_SIZE; z++) {
		for (int x = 0; x < MG08MAP_X_SIZE; x++) {
			MG08Map *pCell;
			pCell = MG08Map::GetCell(x, z);
			if (pCell && pCell->iBox) {
				MG08Osewa3D v(x, 0, z);
				for (int y = 0; y < pCell->iBox; y++) {
					v.y = pCell->iBase + y;
					if (boxIndex < NUM_BLOCKS) {
						pCell->pBlocks[y] = pBlock[boxIndex];
						pBlock[boxIndex]->SetPos(&v);
						if( pCell->iTimeBonus && pCell->iTimeBonus-1==y ){
							pCell->pBlocks[y] = pBBlock[bounsboxIndex];
							pCell->pnBlocks[y] = pBlock[boxIndex];
							pBBlock[bounsboxIndex]->SetPos(&v);
							bounsboxIndex++;

							//ݒẄʒuɈړĂ
							pBlock[boxIndex]->OnFrameMove();
							pBlock[boxIndex]->SetEnable(FALSE);
							
						}
						boxIndex++;
					} else {
						pCell->iBox = (char)y;
						pCell->iHeight = (char)(pCell->iBase + y);
					}
				}
			}
		}
	}
	OSReport("Block is %d.\n", boxIndex);
	for (int i = boxIndex; i < NUM_BLOCKS; i++) {
		pBlock[i]->SetEnable(FALSE);
	}
	for( int i=bounsboxIndex; i<NUM_BBLOCKS; i++ ){
		pBBlock[i]->SetEnable(FALSE);
	}

	MG08Gauge theGauge;
	theGauge.Load(pRes);
	theGauge.SetHand(pHand);

	MG08Timer theTimerObj;
	theTimerObj.Load(pRes);

	C2DObj theStartObj;
	theStartObj.Create(pRes->GetDataPtr("co_start"), "co_start", "co_start");
	theStartObj.AddAnimTransform(pRes->GetDataPtr("co_start"), "co_start", "co_start");
	theStartObj.BindAnime("co_start");
	C2DObj theEndObj;
	theEndObj.Create(pRes->GetDataPtr("co_end"), "co_end", "co_end");
	theEndObj.AddAnimTransform(pRes->GetDataPtr("co_end"), "co_end", "co_end");
	theEndObj.BindAnime("co_end");
	theEndObj.SetVisible(FALSE);

	pRoot->Clear();
	pRoot->PushBack(pBG->GetMdlSimple());
	for (int i = 0; i < NUM_BLOCKS; i++) {
		if (pBlock[i]->IsEnable() ) {
			pRoot->PushBack(pBlock[i]->GetMdlSimple());
		}
	}
	for( int i=0; i<NUM_BBLOCKS; i++ ){
		if( pBBlock[i]->IsEnable() ){
			pRoot->PushBack( pBBlock[i]->GetMdlSimple() );
		}
	}
	for (int i = 0; i < NUM_CATS; i++) {
		pRoot->PushBack(pCats[i]->GetMdlSimple());
	}
	for (int i = 0; i < NUM_CATS; i++) {
		pRoot->PushBack(pDish[i]->GetMdlSimple());
	}
	pRoot->PushBack(pHand->GetMdlSimple());
	for (int i = 0; i < NUM_CATS; i++) {
		MG08Osewa3D v;
		MG08Map *pCell;
		do {
			v.x = rand() % 5;
			v.z = rand() % 3;
//			v.x = (rand() % 4) + 7;
//			v.z = (rand() % 3) + 9;
			pCell = MG08Map::GetCell(&v);
		} while ((pCell == NULL) ||
				 (pCell->eType == CEL_JUNK) ||
			     (pCell->iHeight > 2) ||
			     (pCell->eCat != CAT_NONE));
		v.y = pCell->iHeight;
		pCats[i]->SetPos(&v);
		pCats[i]->SetAnimSpeed(pCats[i]->GetAnimSpeed());
		pCats[i]->SetMotion(CMI_WAIT);
		pCats[i]->SetMapInfo();
		if (!pCats[i]->IsAnchorOn()) {
			pCats[i]->AnchorOn();
		}
	}

	MG08Osewa3D v(5, 5, 4);
//	MG08Osewa3D v(8, 5, 10);
	pHand->SetPos(&v);

	nw4r::g3d::Camera theCam = pRoot->GetCurrentCamera();
	MG08Camera theCamera;
	theCamera.Startup(&theCam);
	pHand->SetCamera(&theCamera);

	pHand->AnchorOn();

	nw4r::g3d::VEC3 pPos(0,0,0);
	nw4r::ef::Effect* pEffect;
	pEffect = CEffect::AddEffect( "e096", MG08EG_HAND, &pPos );

	theTimerObj.SetTimer(MG08_TIMER_MAX);
	CSound::PlayBGM( STRM_MBGM070, 0 );

#ifdef DRAW_CAMERA_INFO
	char szBuffer1[64];
	char szBuffer2[64];
#endif

	CPad pad;
	BOOL bPause = FALSE;
	
	while (TRUE) {
#if 0
		SKPAD_LOOPHEAD();
#endif
#ifdef DRAW_CAMERA_INFO
		szBuffer1[0] = '\0';
		szBuffer2[0] = '\0';
#endif
#if 0
		SKPad *pPad;
		KPADStatus *pStatus = NULL;
		s32 numSamples = 0;
		pPad = SKPad::MainPad();
		if (pPad) {
			numSamples = pPad->Read(pStatus);
			if ((numSamples > 0) && (pStatus[0].wpad_err == WPAD_ERR_NONE)) {
#else
//2009/05/08 ǉ yanai ----------------------------------------------------
		s32 numSamples = 0;
		SKPad *pPad;
		pPad = SKPad::MainPad();
		KPADStatus* pStatus = pad.UpdateInput(FALSE,&numSamples);
		if( pStatus ){
#endif
//܂------------------------------------------------------------------
#ifdef ESCAPEMINIGAMEENABLED
			if (pStatus[0].hold & KPAD_BUTTON_Z) {
				if (pStatus[0].hold & KPAD_BUTTON_C) {
					theCamera.Reset();
				} else {
					// ̈ړ
					if (pStatus[0].ex_status.fs.stick.x > 0.5f) {
						theCamera.RotDelta(0.0f, -0.5f, 0.0f);
					} else if (pStatus[0].ex_status.fs.stick.x < -0.5f) {
						theCamera.RotDelta(0.0f,  0.5f, 0.0f);
					}
					if (pStatus[0].ex_status.fs.stick.y > 0.5f) {
						theCamera.RotDelta(-0.5f, 0.0f, 0.0f);
					} else if (pStatus[0].ex_status.fs.stick.y < -0.5f) {
						theCamera.RotDelta( 0.5f, 0.0f, 0.0f);
					}
				}
			} else {
				// Jʒuړ
				if (pStatus[0].hold & KPAD_BUTTON_C) {
					if (pStatus[0].ex_status.fs.stick.x > 0.5f) {
						theCamera.MoveDelta(0.0f, 0.0f, 0.03f);
					} else if (pStatus[0].ex_status.fs.stick.x < -0.5f) {
						theCamera.MoveDelta(0.0f, 0.0f, -0.03f);
					}
					if (pStatus[0].ex_status.fs.stick.y > 0.5f) {
						theCamera.MoveDelta(0.0f, -0.03f, 0.0f);
					} else if (pStatus[0].ex_status.fs.stick.y < -0.5f) {
						theCamera.MoveDelta(0.0f,  0.03f, 0.0f);
					}
				} else {
					if (pStatus[0].ex_status.fs.stick.x > 0.5f) {
						theCamera.MoveDelta(0.0f, 0.0f, 0.03f);
					} else if (pStatus[0].ex_status.fs.stick.x < -0.5f) {
						theCamera.MoveDelta(0.0f, 0.0f, -0.03f);
					}
					if (pStatus[0].ex_status.fs.stick.y > 0.5f) {
						theCamera.MoveDelta(0.03f, 0.0f, 0.0f);
					} else if (pStatus[0].ex_status.fs.stick.y < -0.5f) {
						theCamera.MoveDelta(-0.03f, 0.0f, 0.0f);
					}
				}
			}
#endif
			if( pHand->IsEnable() ){
				if (pStatus[0].hold & KPAD_BUTTON_RIGHT) {
					pHand->MoveZMinus();
				}
				if (pStatus[0].hold & KPAD_BUTTON_LEFT) {
					pHand->MoveZPlus();
				}
				if (pStatus[0].hold & KPAD_BUTTON_UP) {
					pHand->MoveXMinus();
				}
				if (pStatus[0].hold & KPAD_BUTTON_DOWN) {
					pHand->MoveXPlus();
				}
				if ((pStatus[0].hold & KPAD_BUTTON_PLUS) &&
					(pStatus[0].hold & KPAD_BUTTON_MINUS)) {
					for (int i = 0; i < NUM_CATS; i++) {
						pCats[i]->ClearMapInfo();
					}
					ResetCats(pCats);
				}
#ifdef ESCAPEMINIGAMEENABLED
				if (pStatus[0].trig & KPAD_BUTTON_MINUS) {
					theTimerObj.AddTime(99);
				}
#endif
				if (pStatus[0].trig & KPAD_BUTTON_A) {
					pHand->CatchStart();
				} else {
					if (pStatus[0].trig & KPAD_BUTTON_B) {
						if (pHand->IsCatchSomething()) {
							pHand->ReleaseSomething();
						}
					}
				}
			}
#if 0
			if (pStatus[0].trig & KPAD_BUTTON_PLUS) {
				// AJ[̕\ON/OFF
				for (int i = 0; i < NUM_CATS; i++) {
					if (pCats[i]->IsAnchorOn()) {
						pCats[i]->AnchorOff();
					} else {
						pCats[i]->AnchorOn();
					}
				}
			}
#endif
			if ((pStatus[0].hold & KPAD_BUTTON_1) && (pStatus[0].hold & KPAD_BUTTON_2)) {
				break;
			}
		}
		if( !bPause && g_Dlg.GetStatus()==DS_HIDE ){
//܂------------------------------------------------------------------
			for (int i = 0; i < NUM_BLOCKS; i++) {
				pBlock[i]->OnFrameMove();
			}
			for (int i = 0; i < NUM_BBLOCKS; i++) {
				pBBlock[i]->OnFrameMove();
			}
			for (int i = 0; i < NUM_CATS; i++) {
				pCats[i]->OnFrameMove();
			}
			if ((MG08Cat::GoalInCats() & GOALINCATS_ALL) == GOALINCATS_ALL) {
				theTimerObj.Fix();
			}
			if (MG08Cat::GoalInCats() == (GOALINCATS_ALL | EATINGCATS_ALL)) {
				if (iWaitEating < 0) {
					iWaitEating = 240;
				}
			}
			if (MG08Cat::GoalInCats() == (GOALINCATS_ALL | EATINGCATS_ALL | ENDINGCATS_ALL)) {
				// S[oI
				g_MG08ClearBonus = MG08Hand::CountTimeBonus() * 10000;
				g_MG08Score = theTimerObj.GetSec() * 10000;	// mainɕԂXRAݒ
				theEndObj.SetVisible(TRUE);
			}
			if (iWaitEating > 0) {
				iWaitEating--;
				if (iWaitEating == 0) {
					//NAoݒ
					CEffect::DeleteEmitter(EFFECT_GROUP_ALL);
					CEffect::DeleteParticle(EFFECT_GROUP_ALL);
					theCamera.SetupGoalCamera();
					pRoot->Remove( pHand->GetMdlSimple() );
					pHand->SetEnable(FALSE);
					if( pHand->GetBlock() ){
						pRoot->Remove( pHand->GetBlock()->GetMdlSimple() );
					}
					for (int i = 0; i < NUM_CATS; i++) {
						if (pCats[i]->Freeze()) {
							pCats[i]->SetMotion(CMI_HAPPY_EAT);
							pRoot->Remove(pDish[i]->GetMdlSimple());
							pRoot->PushBack(pEmptyDish[i]->GetMdlSimple());
						}
					}
				//	theEndObj.SetVisible(TRUE);
				}
			}
			for (int i = 0; i < NUM_CATS; i++) {
				pDish[i]->OnFrameMove();
				pEmptyDish[i]->OnFrameMove();
				pHelp[i]->OnFrameMove();
			}
			pHand->OnFrameMove();

			theGauge.OnFrameMove();

			theStartObj.OnFrameMove();
			if (theStartObj.GetVisible() && theStartObj.IsAnimeEnd()) {
				theStartObj.SetVisible(FALSE);
				theTimerObj.Start();
			}
			theEndObj.OnFrameMove();
//2009/05/08 ǉ yanai ----------------------------------------------------
			bPause = FALSE;
			if( g_Dlg.GetStatus()!=DS_HIDE && g_Dlg.GetStatus()!=DS_FADEOUT ){
				g_Dlg.Hide();
			}
		}
		if( !pad.GetStatus()->bConnected ){
			g_Dlg.SetMessageID( ID_DISCONNECT_NEEDNUNCHAKU );
			bPause = TRUE;
		}else{
			bPause = FALSE;
		}
		if( bPause && g_Dlg.GetStatus()==DS_HIDE){
			g_Dlg.Show();
		}else
		if(  !bPause && g_Dlg.GetStatus()!=DS_HIDE && g_Dlg.GetStatus()!=DS_FADEOUT ){
			g_Dlg.Hide();
		}
		g_Dlg.OnFrameMove();
//܂------------------------------------------------------------------
		if (theEndObj.IsAnimeEnd()) {
    		CFader fader;
//			fader.SetColor( 0x00000000 );	2009/05/11 yanai
			fader.SetFader( 60, 0.0f, 255.0f, AC_DECEL );
			while( !fader.IsComplete() ){
				for (int i = 0; i < NUM_BLOCKS; i++) {
					pBlock[i]->OnFrameMove();
				}
				for (int i = 0; i < NUM_BBLOCKS; i++) {
					pBBlock[i]->OnFrameMove();
				}
				for (int i = 0; i < NUM_CATS; i++) {
					pCats[i]->OnFrameMove();
				}
				for (int i = 0; i < NUM_CATS; i++) {
					pDish[i]->OnFrameMove();
					pEmptyDish[i]->OnFrameMove();
				}
				pHand->OnFrameMove();
				theEndObj.OnFrameMove();
				CEffect::OnFrameMove( theCam );
				nw4r::g3d::G3dReset();
		        pRoot->UpdateFrame();
		        pRoot->CalcVtx();
		        pRoot->CalcWorld();
		        pRoot->CalcMaterial();
		        pRoot->CalcView();
		        pRoot->GatherDrawScnObj();
		        pRoot->ZSort();
			    BeforeRender();
		        pRoot->DrawOpa();
		 		pRoot->DrawXlu();
				CEffect::Draw();
				CHelper::InitProjectionMatrix();

				fader.OnFrameMove();

				theStartObj.Draw();
				theEndObj.Draw();
				
				fader.Draw();
				GXDrawDone();
				DoneRender();
//2009/05/11 ǉ yanai ----------------------------------------------------
				CheckResetButton();		//Zbg{^`FbN
//܂------------------------------------------------------------------
				CSound::Update();
			}

			theEndObj.SetVisible(FALSE);
			break;
		}
		if( !bPause && g_Dlg.GetStatus()==DS_HIDE ){
			theTimerObj.OnFrameMove();
			if (theTimerObj.IsFinished()) {
				if ((MG08Cat::GoalInCats() & GOALINCATS_ALL) != GOALINCATS_ALL) {
					theEndObj.SetVisible(TRUE);
				}
			}
		}

		CEffect::OnFrameMove( theCam );

		// Home{^̃`FbN
		if (pStatus && (pStatus[0].trig & KPAD_BUTTON_HOME)) {
			// HBMJn֐Ă
			BeginHBM();
			// HBMtO𗧂Ă
			bHBM = TRUE;
		}

		do {
		    nw4r::g3d::G3dReset();

	        pRoot->UpdateFrame();
	        pRoot->CalcVtx();
	        pRoot->CalcWorld();
	        pRoot->CalcMaterial();
	        pRoot->CalcView();
	        pRoot->GatherDrawScnObj();
	        pRoot->ZSort();
		    BeforeRender();
	        pRoot->DrawOpa();
	        pRoot->DrawXlu();
	        CEffect::Draw();
	        CSound::Update();

			CHelper::InitProjectionMatrix();
			// 2Di`^C~O
			theGauge.Draw();
			theStartObj.Draw();
			theEndObj.Draw();
			theTimerObj.Draw();
#ifdef DRAW_CAMERA_INFO
			// J\
			Writer.SetupGX();
			CFont::Begin();
			Writer.SetCursor( 100.0f, 0.0f );
			Writer.SetTextColor( 0xFF0000FF );
			{
				nw4r::g3d::VEC3 camPos;
				camPos = theCamera.GetPos();
				nw4r::g3d::VEC3 camRot;
				camRot = theCamera.GetRot();
				sprintf(szBuffer1, "Pos (%f, %f, %f)",
					camPos.x, camPos.y, camPos.z);
				sprintf(szBuffer2, "Rot (%f, %f, %f)",
					camRot.x, camRot.y, camRot.z);
			}
			Writer.Printf( szBuffer1 );
			Writer.SetCursor( 100.0f, 30.0f );
			Writer.Printf( szBuffer2 );
#endif
//2009/05/08 ǉ yanai ----------------------------------------------------
			g_Dlg.Draw();
//܂------------------------------------------------------------------
			// bHBMTRUÊƂDrawHBM()Ă
			// GXDrawDone()DrawHBM()ŌĂ΂悤Ȃ̂ŁAdɌĂ΂Ȃ悤ɒ
			if( bHBM ){
				//HBM甲ꍇFALSEԂ܂
				bHBM=DrawHBM();
			}else{
				//`I
				GXDrawDone();
			}
			SCREENCAPTURE();
			DoneRender();
//2009/05/11 ǉ yanai ----------------------------------------------------
			CheckResetButton();		//Zbg{^`FbN
//܂------------------------------------------------------------------
			CSound::Update();
		} while (bHBM);

	}

#ifdef MG08CATCH_ROLLING_CAT
#if 0 // ]̔LLb`鏈
	// \̎ŕs`FbN
	for (int z = 0; z < MG08MAP_Z_SIZE; z++) {
		for (int x = 0; x < MG08MAP_X_SIZE; x++) {
			MG08Map *pCell;
			pCell = MG08Map::GetCell(x, z);
			if (pCell->IsReserved()) {
				char *pOwnerName = NULL;
				for (int i = 0; i < NUM_CATS; i++) {
					if (pCell->pOwner == pCats[i]) {
						if (i == 0) {
							pOwnerName = "Senshu";
						} else if (i == 1) {
							pOwnerName = "Pro";
						} else {
							pOwnerName = "Cherry";
						}
						break;
					}
				}
				if (pOwnerName == NULL) {
					if (pCell->pOwner == pHand) {
						pOwnerName = "Hand";
					} else {
						pOwnerName = "UNKNOWN";
					}
				}
				OSReport("Cell is Reserved! (%d, %d)->[%s, %s, 0x%08x]\n",
						x, z, pOwnerName, MG08Cat::GetCatTypeString(pCell->eCat),
						pCell->pOwner);
			}
		}
	}
#endif
#endif

	CEffect::DeleteEmitter(EFFECT_GROUP_ALL);
	CEffect::DeleteParticle(EFFECT_GROUP_ALL);
	SAFE_DELETE(pBG);
	for (int i = 0; i < NUM_BLOCKS; i++) {
		SAFE_DELETE(pBlock[i]);
	}
	for (int i = 0; i < NUM_BBLOCKS; i++) {
		SAFE_DELETE(pBBlock[i]);
	}
	for (int i = 0; i < NUM_CATS; i++) {
		SAFE_DELETE(pCats[i]);
	}
	for (int i = 0; i < NUM_CATS; i++) {
		SAFE_DELETE(pDish[i]);
		SAFE_DELETE(pEmptyDish[i]);
		SAFE_DELETE(pHelp[i]);
	}
	SAFE_DELETE(pHand);
	SAFE_DESTROY(pRoot);
	SAFE_DELETE( pRes );

	return g_MG08Score;
}
